////////////////////////////////////////////////////////
//
// GEM - Graphics Environment for Multimedia
//
// Implementation file
//
// Copyright (c) 2002-2011 IOhannes m zmölnig. forum::für::umläute. IEM. zmoelnig@iem.at
//      zmoelnig@iem.at
//  For information on usage and redistribution, and for a DISCLAIMER
//  *  OF ALL WARRANTIES, see the file, "GEM.LICENSE.TERMS"
//
//  this file has been generated...
////////////////////////////////////////////////////////

#include "GEMglClearAccum.h"

CPPEXTERN_NEW_WITH_FOUR_ARGS ( GEMglClearAccum, t_floatarg, A_DEFFLOAT,
                               t_floatarg, A_DEFFLOAT, t_floatarg, A_DEFFLOAT, t_floatarg, A_DEFFLOAT);

/////////////////////////////////////////////////////////
//
// GEMglViewport
//
/////////////////////////////////////////////////////////
// Constructor
//
GEMglClearAccum :: GEMglClearAccum      (t_floatarg arg0, t_floatarg arg1,
    t_floatarg arg2, t_floatarg arg3) :
  red(static_cast<GLfloat>(arg0)),
  green(static_cast<GLfloat>(arg1)),
  blue(static_cast<GLfloat>(arg2)),
  alpha(static_cast<GLfloat>(arg3))
{
  m_inlet[0] = inlet_new(this->x_obj, &this->x_obj->ob_pd, &s_float,
                         gensym("red"));
  m_inlet[1] = inlet_new(this->x_obj, &this->x_obj->ob_pd, &s_float,
                         gensym("green"));
  m_inlet[2] = inlet_new(this->x_obj, &this->x_obj->ob_pd, &s_float,
                         gensym("blue"));
  m_inlet[3] = inlet_new(this->x_obj, &this->x_obj->ob_pd, &s_float,
                         gensym("alpha"));
}
/////////////////////////////////////////////////////////
// Destructor
//
GEMglClearAccum :: ~GEMglClearAccum ()
{
  inlet_free(m_inlet[0]);
  inlet_free(m_inlet[1]);
  inlet_free(m_inlet[2]);
  inlet_free(m_inlet[3]);
}

/////////////////////////////////////////////////////////
// Render
//
void GEMglClearAccum :: render(GemState *state)
{
  glClearAccum (red, green, blue, alpha);
}

/////////////////////////////////////////////////////////
// Variables
//
void GEMglClearAccum :: redMess (t_float arg1)          // FUN
{
  red = static_cast<GLfloat>(arg1);
  setModified();
}

void GEMglClearAccum :: greenMess (t_float arg1)        // FUN
{
  green = static_cast<GLfloat>(arg1);
  setModified();
}

void GEMglClearAccum :: blueMess (t_float arg1)         // FUN
{
  blue = static_cast<GLfloat>(arg1);
  setModified();
}

void GEMglClearAccum :: alphaMess (t_float arg1)        // FUN
{
  alpha = static_cast<GLfloat>(arg1);
  setModified();
}


/////////////////////////////////////////////////////////
// static member functions
//

void GEMglClearAccum :: obj_setupCallback(t_class *classPtr)
{
  class_addmethod(classPtr,
                  reinterpret_cast<t_method>(&GEMglClearAccum::redMessCallback),
                  gensym("red"), A_DEFFLOAT, A_NULL);
  class_addmethod(classPtr,
                  reinterpret_cast<t_method>(&GEMglClearAccum::greenMessCallback),
                  gensym("green"), A_DEFFLOAT, A_NULL);
  class_addmethod(classPtr,
                  reinterpret_cast<t_method>(&GEMglClearAccum::blueMessCallback),
                  gensym("blue"), A_DEFFLOAT, A_NULL);
  class_addmethod(classPtr,
                  reinterpret_cast<t_method>(&GEMglClearAccum::alphaMessCallback),
                  gensym("alpha"), A_DEFFLOAT, A_NULL);
};

void GEMglClearAccum :: redMessCallback (void* data, t_float arg0)
{
  GetMyClass(data)->redMess ( static_cast<t_float>(arg0));
}
void GEMglClearAccum :: greenMessCallback (void* data, t_float arg0)
{
  GetMyClass(data)->greenMess ( static_cast<t_float>(arg0));
}
void GEMglClearAccum :: blueMessCallback (void* data, t_float arg0)
{
  GetMyClass(data)->blueMess ( static_cast<t_float>(arg0));
}
void GEMglClearAccum :: alphaMessCallback (void* data, t_float arg0)
{
  GetMyClass(data)->alphaMess ( static_cast<t_float>(arg0));
}
