/* ------------------------------------------------------------------
 * GEM - Graphics Environment for Multimedia
 *
 *  Copyright (c) 2002-2011 IOhannes m zmölnig. forum::für::umläute. IEM. zmoelnig@iem.at
 *     zmoelnig@iem.at
 *  For information on usage and redistribution, and for a DISCLAIMER
 *  OF ALL WARRANTIES, see the file, "GEM.LICENSE.TERMS"
 *
 *  this file has been generated...
 * ------------------------------------------------------------------
 */

#ifndef _INCLUDE__GEM_OPENGL_GEMGLTEXCOORD4S_H_
#define _INCLUDE__GEM_OPENGL_GEMGLTEXCOORD4S_H_

#include "Base/GemGLBase.h"

/*
 CLASS
        GEMglTexCoord4s
 KEYWORDS
        openGL  0
 DESCRIPTION
        wrapper for the openGL-function
        "glTexCoord4s( GLshort s, GLshort t, GLshort r, GLshort q)"
 */

class GEM_EXTERN GEMglTexCoord4s : public GemGLBase
{
  CPPEXTERN_HEADER(GEMglTexCoord4s, GemGLBase);

public:
  // Constructor
  GEMglTexCoord4s (t_float, t_float, t_float, t_float); // CON

protected:
  // Destructor
  virtual ~GEMglTexCoord4s ();
  // Do the rendering
  virtual void  render (GemState *state);

  // variables
  GLshort       s;              // VAR
  virtual void  sMess(t_float); // FUN

  GLshort       t;              // VAR
  virtual void  tMess(t_float); // FUN

  GLshort       r;              // VAR
  virtual void  rMess(t_float); // FUN

  GLshort       q;              // VAR
  virtual void  qMess(t_float); // FUN


private:

  // we need some inlets
  t_inlet *m_inlet[4];

  // static member functions
  static void    sMessCallback (void*, t_float);
  static void    tMessCallback (void*, t_float);
  static void    rMessCallback (void*, t_float);
  static void    qMessCallback (void*, t_float);
};
#endif // for header file
